Loading...
Searching...
No Matches
Ogre::OverlayContainer Class Reference
Optional Components » Overlay

A 2D element which contains other OverlayElement instances. More...

`#include <OgreOverlayContainer.h>`

Inheritance diagram for Ogre::OverlayContainer:
[legend]

## Public Types

typedef MapIterator< ChildContainerMap > | ChildContainerIterator
typedef std::map< String, OverlayContainer * > | ChildContainerMap
typedef MapIterator< ChildMap > | ChildIterator
typedef std::map< String, OverlayElement * > | ChildMap
Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }

## Public Member Functions

| OverlayContainer (const String &name)
| Constructor: do not call direct, use OverlayManager::createOverlayElement.
virtual | ~OverlayContainer ()
void | _addChild (OverlayElement *elem)
void | _notifyParent (OverlayContainer *parent, Overlay *overlay) override
| Overridden from OverlayElement.
void | _notifyViewport () override
| Overridden from OverlayElement.
void | _notifyWorldTransforms (const Matrix4 &xform) override
| Overridden from OverlayElement.
ushort | _notifyZOrder (ushort newZOrder) override
| Overridden from OverlayElement.
void | _positionsOutOfDate (void) override
| Tell the object and its children to recalculate.
void | _removeChild (const String &name)
void | _removeChild (OverlayElement *elem)
void | _update (void) override
| Overridden from OverlayElement.
void | _updateRenderQueue (RenderQueue *queue) override
| Overridden from OverlayElement.
virtual void | addChild (OverlayElement *elem)
| Adds another OverlayElement to this container.
virtual void | addChildImpl (OverlayContainer *cont)
| Add a nested container to this container.
virtual void | addChildImpl (OverlayElement *elem)
| Adds another OverlayElement to this container.
OverlayElement * | clone (const String &instanceName) override
void | copyFromTemplate (OverlayElement *templateOverlay) override
OverlayElement * | findElementAt (Real x, Real y) override
| This returns a OverlayElement at position x,y.
virtual OverlayElement * | getChild (const String &name)
| Gets the named child of this container.
virtual ChildContainerIterator | getChildContainerIterator (void)
| Gets an iterator for just the container children of this object.
virtual ChildIterator | getChildIterator (void)
const ChildMap & | getChildren () const
| Gets all the children of this object.
void | initialise (void) override
| Initialise gui element.
virtual bool | isChildrenProcessEvents () const
| Should this container pass events to their children.
bool | isContainer () const override
| Overridden from OverlayElement.
virtual void | removeChild (const String &name)
| Removes a named element from this container.
virtual void | setChildrenProcessEvents (bool val)
| Should this container pass events to their children.
Public Member Functions inherited from Ogre::OverlayElement
| OverlayElement (const String &name)
| Constructor: do not call direct, use OverlayManager::createElement.
virtual | ~OverlayElement ()
virtual void | _getClippingRegion (RealRect &clippingRegion)
| Gets the clipping region of the element.
virtual Real | _getDerivedLeft (void)
| Gets the 'left' position as derived from own left and that of parents.
virtual Real | _getDerivedTop (void)
| Gets the 'top' position as derived from own left and that of parents.
Real | _getHeight (void) const
| Gets the height of this element in relation to the screen (where 1.0 = screen height).
Real | _getLeft (void) const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
virtual Real | _getRelativeHeight (void)
| Gets the 'height' as derived from own height and metrics mode.
virtual Real | _getRelativeWidth (void)
| Gets the 'width' as derived from own width and metrics mode.
Real | _getTop (void) const
| Gets the top of this element in relation to the screen (where 0 = far top, 1.0 = far bottom).
Real | _getWidth (void) const
| Gets the width of this element in relation to the screen (where 1.0 = screen width).
virtual void | _releaseManualHardwareResources ()
| Notifies that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies that hardware resources should be restored.
void | _setDimensions (Real width, Real height)
| Sets the width and height of this element in relation to the screen (where 1.0 = screen width/height).
void | _setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen height).
void | _setLeft (Real left)
| Sets the left of this element in relation to the screen (where 1.0 = screen width).
void | _setParent (OverlayContainer *parent)
void | _setPosition (Real left, Real top)
| Sets the left and top of this element in relation to the screen (where 1.0 = screen width/height).
void | _setTop (Real top)
| Sets the top of this element in relation to the screen (where 1.0 = screen height).
void | _setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width).
virtual void | _updateFromParent (void)
| Updates this elements transform based on it's parent.
virtual bool | contains (Real x, Real y) const
| Returns true if xy is within the constraints of the component.
const DisplayString & | getCaption (void) const
| Gets the caption for this element.
virtual const ColourValue & | getColour (void) const
| Gets the colour for this element.
Real | getHeight (void) const
| Gets the height of this element in relation to the current GuiMetricsMode.
GuiHorizontalAlignment | getHorizontalAlignment (void) const
| Gets the horizontal alignment for this element.
Real | getLeft (void) const
| Gets the left of this element in relation to the current GuiMetricsMode.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
virtual const String & | getMaterialName (void) const
| Gets the name of the material this element uses.
GuiMetricsMode | getMetricsMode (void) const
| Retrieves the current settings of how the element metrics are interpreted.
const String & | getName (void) const
| Gets the name of this overlay.
OverlayContainer * | getParent ()
| Returns the parent container.
Real | getSquaredViewDepth (const Camera *cam) const override
| Returns the squared distance between the camera and this renderable.
Real | getTop (void) const
| Gets the top of this element in relation to the current GuiMetricsMode (where 0 = top).
virtual const String & | getTypeName (void) const =0
| Gets the type name of the element.
GuiVerticalAlignment | getVerticalAlignment (void) const
| Gets the vertical alignment for this element.
Real | getWidth (void) const
| Gets the width of this element in relation to the current GuiMetricsMode.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
ushort | getZOrder () const
| Returns the zOrder of the element.
void | hide (void)
| Hides this element if it was visible.
bool | isCloneable () const
bool | isEnabled () const
virtual bool | isKeyEnabled () const
bool | isVisible (void) const
| Returns whether or not the element is visible.
virtual void | setCaption (const DisplayString &text)
| Sets the caption on elements that support it.
void | setCloneable (bool c)
virtual void | setColour (const ColourValue &col)
| Sets the colour on elements that support it.
void | setDimensions (Real width, Real height)
| Sets the dimensions of this element in relation to the current GuiMetricsMode.
void | setEnabled (bool b)
void | setHeight (Real height)
| Sets the height of this element in relation to the current GuiMetricsMode.
virtual void | setHorizontalAlignment (GuiHorizontalAlignment gha)
| Sets the horizontal origin for this element.
void | setLeft (Real left)
| Sets the left of this element in relation to the current GuiMetricsMode.
void | setMaterial (const MaterialPtr &mat)
| Sets the the material this element will use.
void | setMaterialName (const String &matName, const String &group=DEFAULT_RESOURCE_GROUP)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | setMetricsMode (GuiMetricsMode gmm)
| Tells this element how to interpret the position and dimension values it is given.
void | setPosition (Real left, Real top)
| Sets the position of the top-left corner in relation to the current GuiMetricsMode (where 0 = top).
void | setTop (Real Top)
| Sets the top of this element in relation to the current GuiMetricsMode (where 0 = top).
virtual void | setVerticalAlignment (GuiVerticalAlignment gva)
| Sets the vertical origin for this element.
void | setVisible (bool visible)
| Shows or hides this element.
void | setWidth (Real width)
| Sets the width of this element in relation to the current GuiMetricsMode.
void | show (void)
| Shows this element if it was hidden.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual void | getRenderOperation (RenderOperation &op)=0
| Gets the render operation required to send this object to the frame buffer.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members

Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Static Public Attributes inherited from Ogre::OverlayElement
static const String & | DEFAULT_RESOURCE_GROUP

## Detailed Description

A 2D element which contains other OverlayElement instances.

This is a specialisation of OverlayElement for 2D elements that contain other elements. These are also the smallest elements that can be attached directly to an Overlay.

OverlayContainers should be managed using OverlayManager. This class is responsible for instantiating / deleting elements, and also for accepting new types of element from plugins etc.

## Member Typedef Documentation

## ChildMap

typedef std::map<String, OverlayElement*> Ogre::OverlayContainer::ChildMap

## ChildIterator

typedef MapIterator<ChildMap> Ogre::OverlayContainer::ChildIterator

## ChildContainerMap

typedef std::map<String, OverlayContainer*> Ogre::OverlayContainer::ChildContainerMap

## ChildContainerIterator

typedef MapIterator<ChildContainerMap> Ogre::OverlayContainer::ChildContainerIterator

## Constructor & Destructor Documentation

## OverlayContainer()

Ogre::OverlayContainer::OverlayContainer | ( | const String & | name | ) |

Constructor: do not call direct, use OverlayManager::createOverlayElement.

Referenced by _notifyParent(), and addChildImpl().

## ~OverlayContainer()

virtual Ogre::OverlayContainer::~OverlayContainer | ( |  | ) |

virtual

## Member Function Documentation

## addChild()

virtual void Ogre::OverlayContainer::addChild | ( | OverlayElement * | elem | ) |

virtual

Adds another OverlayElement to this container.

References Ogre::OverlayElement::OverlayElement().

## addChildImpl() [1/2]

virtual void Ogre::OverlayContainer::addChildImpl | ( | OverlayElement * | elem | ) |

virtual

Adds another OverlayElement to this container.

References Ogre::OverlayElement::OverlayElement().

## addChildImpl() [2/2]

virtual void Ogre::OverlayContainer::addChildImpl | ( | OverlayContainer * | cont | ) |

virtual

Add a nested container to this container.

References OverlayContainer().

## removeChild()

virtual void Ogre::OverlayContainer::removeChild | ( | const String & | name | ) |

virtual

Removes a named element from this container.

## getChild()

virtual OverlayElement * Ogre::OverlayContainer::getChild | ( | const String & | name | ) |

virtual

Gets the named child of this container.

References Ogre::OverlayElement::OverlayElement().

## initialise()

void Ogre::OverlayContainer::initialise | ( | void |  | ) |

override virtual

Initialise gui element.

Implements Ogre::OverlayElement.

Reimplemented in Ogre::PanelOverlayElement.

## _addChild()

void Ogre::OverlayContainer::_addChild | ( | OverlayElement * | elem | ) |

References Ogre::OverlayElement::OverlayElement().

## _removeChild() [1/2]

void Ogre::OverlayContainer::_removeChild | ( | OverlayElement * | elem | ) |

inline

References Ogre::OverlayElement::OverlayElement(), _removeChild(), and Ogre::OverlayElement::getName().

Referenced by _removeChild().

## _removeChild() [2/2]

void Ogre::OverlayContainer::_removeChild | ( | const String & | name | ) |

## getChildren()

const ChildMap & Ogre::OverlayContainer::getChildren | ( |  | ) | const

inline

Gets all the children of this object.

## getChildIterator()

virtual ChildIterator Ogre::OverlayContainer::getChildIterator | ( | void |  | ) |

virtual

Deprecated
  use getChildren(

## getChildContainerIterator()

virtual ChildContainerIterator Ogre::OverlayContainer::getChildContainerIterator | ( | void |  | ) |

virtual

Gets an iterator for just the container children of this object.

Good for cascading updates without having to use RTTI

## _positionsOutOfDate()

void Ogre::OverlayContainer::_positionsOutOfDate | ( | void |  | ) |

override virtual

Tell the object and its children to recalculate.

Reimplemented from Ogre::OverlayElement.

## _update()

void Ogre::OverlayContainer::_update | ( | void |  | ) |

override virtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

## _notifyZOrder()

ushort Ogre::OverlayContainer::_notifyZOrder | ( | ushort | newZOrder | ) |

override virtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

## _notifyViewport()

void Ogre::OverlayContainer::_notifyViewport | ( |  | ) |

override virtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

## _notifyWorldTransforms()

void Ogre::OverlayContainer::_notifyWorldTransforms | ( | const Matrix4 & | xform | ) |

override virtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

## _notifyParent()

void Ogre::OverlayContainer::_notifyParent | ( | OverlayContainer * | parent,
|  | Overlay * | overlay )

override virtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

References OverlayContainer().

## _updateRenderQueue()

void Ogre::OverlayContainer::_updateRenderQueue | ( | RenderQueue * | queue | ) |

override virtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

Reimplemented in Ogre::PanelOverlayElement.

## isContainer()

bool Ogre::OverlayContainer::isContainer | ( |  | ) | const

inline override virtual

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

## isChildrenProcessEvents()

virtual bool Ogre::OverlayContainer::isChildrenProcessEvents | ( |  | ) | const

inline virtual

Should this container pass events to their children.

## setChildrenProcessEvents()

virtual void Ogre::OverlayContainer::setChildrenProcessEvents | ( | bool | val | ) |

inline virtual

Should this container pass events to their children.

## findElementAt()

OverlayElement * Ogre::OverlayContainer::findElementAt | ( | Real | x,
|  | Real | y )

override virtual

This returns a OverlayElement at position x,y.

Reimplemented from Ogre::OverlayElement.

References Ogre::OverlayElement::OverlayElement().

## copyFromTemplate()

void Ogre::OverlayContainer::copyFromTemplate | ( | OverlayElement * | templateOverlay | ) |

override virtual

Reimplemented from Ogre::OverlayElement.

References Ogre::OverlayElement::OverlayElement().

## clone()

OverlayElement * Ogre::OverlayContainer::clone | ( | const String & | instanceName | ) |

override virtual

Reimplemented from Ogre::OverlayElement.

References Ogre::OverlayElement::OverlayElement().

The documentation for this class was generated from the following file:

- OgreOverlayContainer.h